<script lang="ts" context="module">
export async function load({session}) {
    return {
        props: {
            sess: session.sess,
            list: await Api.User.list(session.sess)
        }
    }
}
</script>
<script lang="ts">
import { goto } from "$app/navigation";

import * as Api from "../../api/Api";
import {formatDuration} from "../../util/DateFormat";

export let list: Array<Api.UserInfo>, sess;

let hours = {};
let fhours = {};

list.forEach(user => {
    hours[user.usr] = 0;
    fhours[user.usr] = "...";
    Api.User.log(sess, user.usr).then(log => {
        let bsTime = 0;
        log.forEach(entry => {
            if (entry.joined > 1641625200) { // 8 Jan 2022 @ 00:00 (kickoff day)
                // see ./[id]/index.svelte
                bsTime += (entry.left - entry.joined <= 7 * 60 * 60) ? (entry.left - entry.joined) : 0;
            }
        });
        hours[user.usr] = bsTime;
        fhours[user.usr] = formatDuration(bsTime);
    });
});

let sort: string;

// time sorts by name if equal
const sortTimeAsc = () => {
    sort = "ta";   
    list = list.sort((a, b) => (hours[a.usr] != hours[b.usr] ? hours[a.usr] - hours[b.usr] : (a.name > b.name ? 1 : -1)));
}
const sortTimeDesc = () => {
    sort = "td";
    list = list.sort((a, b) => (hours[b.usr] != hours[a.usr] ? hours[b.usr] - hours[a.usr] : (a.name > b.name ? 1 : -1)));
}
const sortNameAsc = () => {
    sort = "na";
    list = list.sort((a, b) => (a.name > b.name ? 1 : -1));
}
const sortNameDesc = () => {
    sort = "nd";
    list = list.sort((a, b) => (a.name < b.name ? 1 : -1));
}

sortNameAsc();
</script>

<style>
    .users {
        width: 100%;
        border-collapse: collapse;
        font-size: 0.9rem;
    }

    .users tbody tr:nth-child(odd) {
        background-color: #dddddd;
    }
    .users th {
        text-align: left;
    }

    .sort {
        cursor: pointer;
    }
    .sort.disabled {
        color: #8d8d8d;
    }

    .users a {
        color: inherit;
        text-decoration: none;
    }
    .users a::after {
        content: "\2009\25cb\00a0";
        color: #faa811;
    }
    .users a:hover::after {
        content: "\2009\00a0\25cb";
    }
</style>

<svelte:head>
    <title>Users | AZtendance</title>
</svelte:head>

<h2>User List</h2>

<table class="users">
    <thead>
        <tr>
            <th>ID</th>
            <th>
                Name
                <span on:click={sortNameAsc} title="Sort by name (ascending)"
                    class="sort {sort == "na" ? "disabled" : ""}">&#9650;</span>
                <span on:click={sortNameDesc} title="Sort by name (descending)"
                    class="sort {sort == "nd" ? "disabled" : ""}">&#9660;</span>
            </th>
            <th>
                <span title="Build Season Time">Hours</span>
                <span on:click={sortTimeAsc} title="Sort by hours (ascending)"
                    class="sort {sort == "ta" ? "disabled" : ""}">&#9650;</span>
                <span on:click={sortTimeDesc} title="Sort by hours (descending)"
                    class="sort {sort == "td" ? "disabled" : ""}">&#9660;</span>
            </th>
        </tr>
    </thead>
    <tbody>
        {#each list as user}
        <tr on:click={() => goto('/users/' + user.usr)}>
            <td><a href="/users/{user.usr}">{user.usr}</a></td>
            <td>{user.name}</td>
            <td>{fhours[user.usr]}</td>
        </tr>
        {/each}
    </tbody>
</table>